%% Ej 3 TP 1  -  SyS 2017

%// Autor: JS - JC - CE
%// Ejemplo de transformacion de la variable independiente y su grafico
%   adecuado.

% Limpiamos la ventana de comandos, borramos todas las variables, cerramos
% todas las figuras.
clc, clear all, close all;

% Vector de tiempos
t = [-4:0.01:6];

% Seal del ejercicio 3
h = senialEj3(t);

%%

% Se abre una nueva figura. Los parmetros son para que la figura aparezca
% maximizada en la pantalla.
figure('units','normalized','outerposition',[0 0 1 1]);

% Graficamos la seal original.
plot(t,h,'lineWidth',3);

% Tamao de letra y letreros de los ejes. Para ver todos los parmetros que
% se pueden modificar escribir: get(gca) (gca refiere al 'axes' actual)
% Tambin escribiendo: set(gca), matlab ofrece las posibilidades que puede
% tomar cada campo. Lo mismo con gcf (figura actual).
set(gca,'fontSize',14);
xlabel('t');
ylabel('h(t)');

% Ajustamos la escala del eje y para visualizar mejor.
ylim([-0.5 2.5]);

% Grilla
grid on;

%%

% Primero se escala la VI en 2, y luego se hace una traslacin en 3/2.
h1 = senialEj3(2*t);
h2 = senialEj3(2*(t-3/2));

figure('units','normalized','outerposition',[0 0 1 1]);

% Graficamos la seal original, y las seales modificadas.
plot(t,h,t,h1,t,h2,'lineWidth',3);

set(gca,'fontSize',14);
xlabel('t');
legend('h(t)','h(2*t)','h(2*(t-3/2))')
ylim([-0.5 2.5]);
grid on;

%%
% Primero se hace una traslacin en 3, y luego se escala la VI en 2.
h3 = senialEj3(t-3);
h4 = senialEj3((2*t)-3);

figure('units','normalized','outerposition',[0 0 1 1]);

% Graficamos la seal original, y las seales modificadas.
plot(t,h,t,h3,t,h4,'lineWidth',3);

set(gca,'fontSize',14);
xlabel('t');
legend('h(t)','h(t-3)','h(2*t-3)')
ylim([-0.5 2.5]);
grid on;

%%
% Comparacin
figure('units','normalized','outerposition',[0 0 1 1]);

% Subplot me permite hacer varias grficas dentro de una misma figura. Ver
% cmo funciona escribiendo: help subplot
subplot(2,1,1)
plot(t,h,t,h1,'lineWidth',1.5)
hold on,
plot(t,h2,'lineWidth',3,'color','red');
set(gca,'fontSize',14);
xlabel('t');
legend('h(t)','h(2*t)','h(2*(t-3/2))')
ylim([-0.5 2.5]);
grid on;

subplot(2,1,2)
plot(t,h,t,h3,'lineWidth',1.5)
hold on,
plot(t,h4,'lineWidth',3,'color','red');
set(gca,'fontSize',14);
xlabel('t');
legend('h(t)','h(t-3)','h(2*t-3)')
ylim([-0.5 2.5]);
grid on;

%%
figure('units','normalized','outerposition',[0 0 1 1]);

% Graficamos la seal original, y la seal modificada.
plot(t,h2,'lineWidth',3,'color','red');
hold on
plot(t,h4,'lineWidth',3,'color','black','lineStyle','--');

set(gca,'fontSize',14);
xlabel('t');
legend('h(2*(t-3/2))','h(2*t-3)')
ylim([-0.5 2.5]);
grid on;

%% a)

% Necesita en la misma carpeta las funciones 'plot_SR' y 'stem_SR'.

clc, clear all, close all;

t = [-4:0.01:6];
xa = senialEj3(t+1);

plot_SR([t(1) t(end) -0.5 2.5],'t','$h(t+1)$','TP 1 - Ej 3 - $a)$',20,t,xa)

%% b)
clc, clear all, close all;

t = [-4:0.01:6];
xb = senialEj3(2*t-3);

plot_SR([t(1) t(end) -0.5 2.5],'t','$h(2t-3)$','TP 1 - Ej 3 - $b)$',20,t,xb)

%% c)
clc, clear all, close all;

t = [-20:0.01:6];
xc = 2*senialEj3(-0.5*(t+10));

plot_SR([t(1) t(end) -0.5 4.5],'t','$2h(-0.5(t+10))$','TP 1 - Ej 3 - $c)$',20,t,xc)

%% d)
clc, clear all, close all;

t = [-6:0.01:6];
xd = senialEj3(t/2).*((t>=-2) & (t<=2)); % Si no, creen la funcin u(t).

plot_SR([t(1) t(end) -0.5 4.5],'t','$h(t/2)[u(t+2)-u(t-2)]$','TP 1 - Ej 3 - $d)$',20,t,xd)

%% e)
clc, clear all, close all;

t = [-2:0.01:2];
xe = senialEj3(t.^2); % El punto es para realizar la operacin elemento a elemento.

plot_SR([t(1) t(end) -0.5 3],'t','$h(t^2)$','TP 1 - Ej 3 - $e)$',20,t,xe)

%% f)
clc, clear all, close all;

t = [-5:0.01:5];
xf = senialEj3(1./t); % El punto es para realizar la operacin elemento a elemento.

plot_SR([t(1) t(end) -0.5 3],'t','$h(1/t)$','TP 1 - Ej 3 - $f)$',20,t,xf)

%% g)
clc, clear all, close all;

n = [-6:1:6];
xg = secuenciaEj3(n-1);

stem_SR([n(1) n(end) -0.5 1.5],'n','$x[n-1]$','TP 1 - Ej 3 - $g)$',20,n,xg)

%% h)
clc, clear all, close all;

n = [-6:1:6];
xh = secuenciaEj3(2*n);

stem_SR([n(1) n(end) -0.5 1.5],'n','$x[2n]$','TP 1 - Ej 3 - $h)$',20,n,xh)

%% h)
clc, clear all, close all;

n = [-6:1:6];
xh = secuenciaEj3(2*n);

stem_SR([n(1) n(end) -0.5 1.5],'n','$x[2n]$','TP 1 - Ej 3 - $h)$',20,n,xh)

%% i)
clc, clear all, close all;

n = [-6:1:6];
xi = secuenciaEj3(n.^2);

stem_SR([n(1) n(end) -0.5 1.5],'n','$x[n^2]$','TP 1 - Ej 3 - $i)$',20,n,xi)

%% j)
clc, clear all, close all;

n = [-6:1:6];
xj = 0.5*secuenciaEj3(n).*(1+(-1).^n);

stem_SR([n(1) n(end) -0.5 1.5],'n','$0.5x[n](1+(-1)^n)$','TP 1 - Ej 3 - $j)$',20,n,xj)

%% k)
clc, clear all, close all;

t = [-4:0.01:4];
xk = 0.5*(senialEj3(t)-senialEj3(-t));

plot_SR([t(1) t(end) -1.5 1.5],'t','$Impar\{ h(t) \}$','TP 1 - Ej 3 - $k)$',20,t,xk)

%% l)
clc, clear all, close all;

n = [-6:1:6];
xl = 0.5*(secuenciaEj3(n) + secuenciaEj3(-n));

stem_SR([n(1) n(end) -0.5 1.5],'n','$Par\{ x{n} \}$','TP 1 - Ej 3 - $l)$',20,n,xl)