%% Ej 7 TP 1  -  SyS 2017

%// Autor: MEG
%// Funcion de variable aleatoria. Esperanza.

% a)

%% Generacion de VA uniforme [0,1]//%

clear all;close all;clc

N=10e6;                 %Cantidad de Numeros Aleatorios a Generar.
B=50;                   %Nmero de intervalos en el Histograma
u=rand(1,N);            %Vector de 1xN de valores uniformemete distribuidos en el intevalo [0,1].

% Transformacion de VA uniforme [0,1] //%

c=9e-9+((11e-9)-9e-9)*u;  %Vector de 1xN de valores de Capacidad uniformemete distribuidos en el intevalo [9nf,11nf]

% Valores de capacidad

[altC,binC] = hist(c,B);                                % Histograma de la capacidad.
figure('units','normalized','outerposition',[0 0 1 1])  % Creo y maximizo figura.
subplot(2,1,1);                                         % Edicin Grfico N1
bar(binC,altC/N/(binC(2)-binC(1)));grid on;             % Grafico histograma normalizado. Grilla.
cap = [8e-9:1e-12:12e-9];                               % Valores de capacidad.
fdpC = 1e9/2.*((cap > 9e-9)&(cap < 11e-9));             % Densidad de prob.
hold on, plot(cap, fdpC,'r','LineWidth',3);             % Grafico la densidad
axis([8e-9 12e-9 0 0.6e9]);                             % Limites de ejes
set(gca, 'FontSize', 16);                               % Tamao de letra para la leyenda y ejes.
xlabel('$c$','Interpreter','Latex');                    % Nombro el eje x.
ylabel('$f_{C}$','Interpreter','Latex');                % Nombro el eje y.
% Coloco ttulo para el grfico.
title('Comparacion entre histograma y densidad de probabilidad','Interpreter','Latex'); 

% Frecuencia de Corte Circuito RC

R=1;                   % Valor de la Resistencia
f=1./(2*pi*R.*c);      % Vector de 1xN de valores de Frecuencias de corte obtenidas

[altf,binf] = hist(f,B);                                % Histograma de la frecuencia de corte.
subplot(2,1,2);                                         % Edicin Grfico N2
bar(binf,altf/N/(binf(2)-binf(1)));grid on;             % Grafico histograma normalizado. Grilla.
frec = [14e6:1e3:18e6];                                 % Valores de frecuencia en Hz
% Densidad de prob.
fdpF = 1e9*2*pi./(2*(frec*2*pi).^2).*((frec > 1e9/(11*2*pi))&(frec < 1e9/(9*2*pi))); 
hold on, plot(frec, fdpF,'r','LineWidth',3);            % Grafico la densidad
axis([14e6 18e6 0 0.5e-6]);                             % Limites de ejes
set(gca, 'FontSize', 16);                               % Tamao de letra para la leyenda y ejes.
xlabel('$f$','Interpreter','Latex');                    % Nombro el eje x.
ylabel('$f_{F}$','Interpreter','Latex');                % Nombro el eje y.
% Coloco ttulo para el grfico.
title('Comparacion entre histograma y densidad de probabilidad','Interpreter','Latex');

%% Clculo aproximado de la Esperanza de la Frecuencia de corte

[h,l]=hist(f,B);                            %h contiene el numero de apariciones, l es el valor central del intervalo donde aparece.
d=(l(2)-l(1));                              %Ancho de los intervalos del histograma
p=h/(N*d);                                  %La densidad de probabilidad se estima diviendo el numero de apariciones en el intervalo por el numero total de ensayos
                                            %y el ancho del intervalo.
EspdeFreq=sum(p.*l*d)                       %Multiplico el valor que toma la VA por su densidad probabilidad y el ancho del intervalo elemento a elemento   
                                            %y sumo todos los elementos del vector
Idesc=sum(p*d);                             %Compruebo que la integral de la funcin densidad de probabilidad es igual a 1
[a,b]=hist(c,B);                            %a contiene el numero de apariciones, b es el valor central del intervalo donde aparece.
k=a/(N*d);                                  %La densidad de probabilidad se estima diviendo el numero de apariciones en el intervalo por el numero total de ensayos
                                            %y el ancho del intervalo.
EspDeCap=sum(k.*b*d)                        %Multiplico el valor que toma la VA por su densidad de probabilidad y el ancho del intervalo elemento a elemento 
                                            %y sumo todos los elementos del vector
Iunif=sum(k*d);                             %Compruebo que la integral de la funcin densidad de probabilidad es igual a 1

% Tambien puede calcular la Esperanza utilizando integracion numerica. 
% Busque por integral(fun,xmin,xmax)



